'Shareaza Daily Updater v0.20
scriptVersion = "0.20"

' Please add comments and requests in the Shareaza General Discussion forum indicated below
' https://sourceforge.net/apps/phpbb/shareaza/viewtopic.php?f=2&t=224&sid=c23287926dd834bb9ce0735861446499
' Modified by FractalMode using Notepad++
' Additional modifications by zero9999

VerboseMode = 0   'Set this to (0/1) to (kill/show) the popup status messages

Set oShell = CreateObject("WScript.Shell")

Const TIMEOUT = 5
Const POPUP_TITLE = "Script Checkpoint"
POPUP_PROMPT = vbInformation+vbYesNo+vbDefaultButton1

if VerboseMode >= "1" then
  Message = "Shareaza Daily Updater v" & scriptVersion
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

' --------------------------------------------------------------------------------------------------------------------------
' Set installer working directory
' --------------------------------------------------------------------------------------------------------------------------
if WScript.Version >= "5.6" then
  ' For WScript >= 5.6
  workingPath = oShell.CurrentDirectory & "\"
else
  ' Manual for WScript < 5.6
  workingPath = oShell.ExpandEnvironmentStrings("%TEMP%") & "\"
end if

' --------------------------------------------------------------------------------------------------------------------------
' Determine the URL of todays installer
' --------------------------------------------------------------------------------------------------------------------------
'webRoot = "http://shareaza.trillinux.org/builds/installer/"  Old debug builds location
'http://shareaza.negatis.com/Shareaza_2.4.0.4_Win32_Release_r8218_2009-10-03.exe  Debug builds page of Shareaza redirects here
'http://sourceforge.net/apps/trac/shareaza/changeset  Title gives today's release number

webroot = "http://shareaza.negatis.com/" 
webRelease = "http://sourceforge.net/apps/trac/shareaza/changeset"

' --------------------------------------------------------------------------------------------------------------------------
' Get Release number
' --------------------------------------------------------------------------------------------------------------------------

REM Sub BlockCommentBegin1

REM Set xml = CreateObject("Microsoft.XMLHTTP")
REM xml.Open "GET", webRelease, False
REM version = ScriptEngineMajorVersion & "." & ScriptEngineMinorVersion & "." & ScriptEngineBuildVersion
REM xml.setRequestHeader "User-Agent", "Shareaza Daily Update Script " & scriptVersion & " (using: VBScript/" & version & ")"
REM xml.Send

REM Wscript.Echo xml.responseText
REM ' Wscript.Echo xml.responseXML Should return XMLized DOM if server sends as MIME type text/xml 

REM End Sub

Set domHTML = Wscript.getObject(webRelease)
 for i = 1 to 10
 Wscript.Sleep 100
 if domHTML.title <> "" then exit for
 next
 
if VerboseMode >= "1" then
  Message = domHTML.title
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT 
else
end if

' Set xml = Nothing

REM strPhrase = domHTML.title
REM strExtract = Mid(strPhrase, 11, 4)
REM Wscript.Echo strExtract

today = Date()
' release = "r8210"
release = "r" & Mid(domHTML.title, 11, 4)

if VerboseMode >= "1" then
  Message = "Current Shareaza release is " & release
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

aMonth = CStr(Month(today))
zero = String(2 - Len(aMonth), "0")
padMonth = zero & aMonth

aDay = CStr(Day(today))
zero = String(2 - Len(aDay), "0")
padDay = zero & aDay

webLocation = webRoot & "Shareaza_2.4.0.4_Win32_Release_" & release & "_" & Year(today) & "-" & padMonth & "-" & padDay & ".exe"

' --------------------------------------------------------------------------------------------------------------------------
' Download  Installer
' --------------------------------------------------------------------------------------------------------------------------

if VerboseMode >= "1" then
  Message = "Begin download of current installer."
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "GET", webLocation, False
version = ScriptEngineMajorVersion & "." & ScriptEngineMinorVersion & "." & ScriptEngineBuildVersion
xml.setRequestHeader "User-Agent", "Shareaza Daily Update Script " & scriptVersion & " (using: VBScript/" & version & ")"
xml.Send


downloadSuccess = false
while downloadSuccess <> true
if xml.status = 404 then
  aDay = aDay-1
  if aDay = 0 then
	aDay = 31
	aMonth = aMonth-1
	zero = String(2 - Len(aMonth), "0")
	padMonth = zero & aMonth
  end if
  zero = String(2 - Len(aDay), "0")
  padDay = zero & aDay
  webLocation = webRoot & "Shareaza_2.4.0.4_Win32_Release_" & release & "_" & Year(today) & "-" & padMonth & "-" & padDay & ".exe"
  xml.Open "GET", webLocation, False 
  xml.setRequestHeader "User-Agent", "Shareaza Daily Update Script " & scriptVersion & " (using: VBScript/" & version & "; yesterday)"
  xml.Send
  if xml.status >= 200 and xml.status < 300 then
    downloadSuccess = true
  end if
else
  downloadSuccess = true
end if
wend

if downloadSuccess = true then
  fileName = "Shareaza_2.4.0.4_Win32_Release_" & release & "_" & Year(today) & "-" & padMonth & "-" & padDay & ".exe"
  set oStream = createobject("Adodb.Stream")
  Const adTypeBinary = 1
  Const adSaveCreateOverWrite = 2
  Const adSaveCreateNotExist = 1

  oStream.type = adTypeBinary
  oStream.open
  oStream.write xml.responseBody
  oStream.savetofile workingPath & fileName, adSaveCreateOverWrite
  oStream.close
  set oStream = nothing
  Set xml = Nothing

if VerboseMode >= "1" then
  Message = "Current installer downloaded to " & workingPath & filename & "."
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

  ' --------------------------------------------------------------------------------------------------------------------------
  'Kill running Shareaza processes
  ' --------------------------------------------------------------------------------------------------------------------------

if VerboseMode >= "1" then
  Message = "Killing running Shareaza processes." 
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if 

  strComputer = "."
  Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" _
    & strComputer & "\root\cimv2")
  Set colProcessList = objWMIService.ExecQuery _
    ("Select * from Win32_Process Where Name = 'Shareaza.exe'")
  For Each objProcess in colProcessList
    objProcess.Terminate()
  Next

if VerboseMode >= "1" then
  Message = "Shareaza processes terminated." 
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

  ' -------------------------------------------------------------------------------------------------------------------------
  'Run Installer
  ' -------------------------------------------------------------------------------------------------------------------------

if VerboseMode >= "1" then
  Message = "Running Shareaza installer."
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if

  oShell.Run """" & workingPath & ""& fileName &""" /VERYSILENT /SP- /SUPPRESSMSGBOXES /NORESTART", 0, TRUE

if VerboseMode >= "1" then
  Message = "Shareaza install completed."
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if
  
  ' ---------------------------------------------------------------------------------------------------------------------------
  'Delete Installer
  ' ---------------------------------------------------------------------------------------------------------------------------
  Set fileSystemObj = CreateObject("Scripting.FileSystemObject")
  Set razaInstaller = fileSystemObj.GetFile(workingPath & fileName)
  razaInstaller.Delete


  ' --------------------------------------------------------------------------------------------------------------------------
  'Run Shareaza
  ' --------------------------------------------------------------------------------------------------------------------------
  
  Set oEnv = oShell.Environment("System")
  if InStr(oEnv("PROCESSOR_ARCHITECTURE"), "64") <> 0 then
  installPath = oShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Shareaza\")
  else
  installPath = oShell.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Shareaza\")
  end if 

  oShell.Run """" & installPath & "\Shareaza.exe"" /nowarn  /nosplash /tray" , 7, FALSE
  
if VerboseMode >= "1" then
  Message = "Shareaza has been restarted.  Update to " & "Shareaza_2.4.0.4_Win32_Release_" & release & " is complete."
  oShell.Popup Message,TIMEOUT,POPUP_TITLE,POPUP_PROMPT
else
end if
  
end if